/* 32Soft - 32Printer compatible version      11/22/2013                */

/* fmwurp.p - WHERE-USED REPORT                                         */
/* Copyright 1986-2004 QAD Inc., Carpinteria, CA, USA.                  */
/* All rights reserved worldwide.  This is an unpublished work.         */
/* web convert fmwurp.p (converter v1.00) Tue Sep 30 12:00:21 1997 */
/* web tag in fmwurp.p (converter v1.00) Mon Sep 29 14:35:57 1997 */
/*F0PN*/ /*K106*/ /*                                                       */
/*V8:ConvertMode=Report                                        */
/* REVISION: 1.0      LAST EDIT:     06/03/86   BY: EMB                 */
/* REVISION: 1.0      LAST EDIT:     08/29/86   BY: EMB *12*            */
/* REVISION: 2.1      LAST EDIT:     10/19/87   BY: WUG *A94*           */
/* REVISION: 4.0      LAST EDIT:     01/05/88   BY: RL  *A118*          */
/* REVISION: 4.0      LAST EDIT:     01/06/88   BY: RL  *A122*          */
/* REVISION: 4.0      LAST EDIT:     02/16/88   BY: FLM *A175*          */
/* REVISION: 4.0      LAST EDIT:     08/16/90   BY: WUG *D051*          */
/* REVISION: 7.2      LAST MODIFIED: 11/02/92   BY: pma *G265*          */
/* REVISION: 8.6      LAST MODIFIED: 10/15/97   BY: ays *K106*          */
/* REVISION: 9.1      LAST MODIFIED: 03/24/00 BY: *N08T* Annasaheb Rahane */
/* REVISION: 9.1      LAST MODIFIED: 08/14/00 BY: *N0L0* Jacolyn Neder     */

/*G265***********************************************************************/
/*                   COMBINED BMWURP.P & FMWURP.P AND                       */
/*                     MOVED ENTIRE EXISTING LOGIC                          */
/*                       TO BMWURPA.P & BMWORPA.I                           */
/*       SINCE CHANGES TO FMWURP.P ARE NOT SHOWN ON BMWURPA.P, THE          */
/*       ORIGINAL LOGIC OF FMWURP.P IS SHOWN COMMMENTED OUT BELOW.          */
/*                                                                          */
/*       (NOTE: THE REPORT PRODUCED IS IDENTICAL TO THE PREVIOUS ONE)       */
/*G265***********************************************************************/

/*G265*/ {mfdeclre.i}
{gplabel.i &ClearReg=yes} /* EXTERNAL LABEL INCLUDE */
/*K106*/ {wbrp01.i}

/*G265*/ define new shared variable transtype as character format "x(4)".

/*G265*/ transtype = "FM".
/*G265*/ {gprun.i ""xxbmwurpa.p""}

/*G265**********************************************************************/
/*G265***********************  MOVED  TO  **********************************/
/*G265***********************  BMWURPA.P  **********************************/
/*G265***********************************************************************
define variable comp like ps_comp.
define variable level as integer.
define variable maxlevel as integer format ">>>" label "Levels".
define variable eff_date like exd_eff_date.
define variable component like ps_comp.
define variable component1 like ps_comp.
define variable component2 like ps_comp.
define variable skpge like mfc_logical initial no
   label "New Page Each Component".

define buffer ptmstr for pt_mstr.
define variable desc1 like pt_desc1.
define variable um like pt_um.
define variable phantom like mfc_logical format "yes" label "Ph".
define variable iss_pol like pt_iss_pol format "/no".
define variable record as integer extent 100.
define variable lvl as character format "x(11)" label "Level".
define variable s_qty_per as character format "x(11)".
define variable batch_qty like pt_batch.

/* DISPLAY TITLE */
{mfdtitle.i "b+ "} /*G265*/
eff_date = today.

form
   component1     colon 25
   component2     label {t001.i} colon 49 skip
/*G265*/ skip(1)
   eff_date       colon 25 skip
   maxlevel       colon 25 skip
   skpge          colon 25 skip
with frame a width 80 side-labels.

/*DETAIL FORM */
form
   lvl
   ps_par
   ps_ref
   ps_qty_per_b
   ps_qty_type
   pt_batch
   pt_um
   pt_phantom
   ps_ps_code
   pt_iss_pol
   ps_start
   ps_end
   ps_scrp_pct
   ps_lt_off
with frame det2 down width 132.

repeat:
   /* input form */
   if component2 = hi_char then component2 = "".

   update component1 component2 eff_date maxlevel skpge with frame a.

   bcdparm = "".
   {mfquoter.i component1 }
   {mfquoter.i component2 }
   {mfquoter.i eff_date   }
   {mfquoter.i maxlevel   }
   {mfquoter.i skpge      }

   if component2 = "" then component2 = hi_char.

   /* SELECT PRINTER  */
   {mfselbpr.i "printer" 132}
   {mfphead.i}

   for each pt_mstr where pt_part >= component1 and
   pt_part <= component2 no-lock:
      comp = pt_part.
      maxlevel = min(maxlevel,99).
      level = 1.
      find first ps_mstr use-index ps_comp where ps_comp = comp
      no-lock no-error.
      if not available ps_mstr then next.

      component = comp.

      /* START DISPLAY */
      display "COMPONENT" @ lvl comp @ ps_par with frame det2.
      if pt_batch <> 1 then display pt_batch with frame det2.
      else display "" @ pt_batch with frame det2.
      display pt_um pt_phantom pt_iss_pol with frame det2.
      down 1 with frame det2.

      if page-size - line-count < 1 then do:
     page.
     down 1 with frame det2.
      end.
      put pt_desc1 at 13 space pt_desc2 skip.

      repeat:
     if not available ps_mstr then do:
        repeat:
           level = level - 1.
           if level < 1 then leave.
           find ps_mstr where recid(ps_mstr) = record[level]
           no-lock no-error.
           comp = ps_comp.
           find next ps_mstr use-index ps_comp where ps_comp = comp
           no-lock no-error.
           if available ps_mstr then leave.
        end.
     end.
     if level < 1 then leave.

     if eff_date = ? or (eff_date <> ? and
     (ps_start = ? or ps_start <= eff_date)
     and  (ps_end = ? or eff_date <= ps_end)) then do:
        desc1 = "Item not in inventory".
        um = "".
        iss_pol = no.
        phantom = no.
        find ptmstr where pt_part = ps_par no-lock.

        record[level] = recid(ps_mstr).
        lvl = "........".
        lvl = substring(lvl,1,min (level - 1,10)) + string(level).
        if length(lvl) > 11 then lvl = substring(lvl,length (lvl) - 10,11).

        display lvl ps_par ps_ref
        ps_qty_per_b ps_qty_type with frame det2.
        if ptmstr.pt_batch <> 1 then
           display ptmstr.pt_batch @ pt_mstr.pt_batch with frame det2.
        else display "" @ pt_mstr.pt_batch with frame det2.
        display
        ptmstr.pt_um @ pt_mstr.pt_um
        ptmstr.pt_phantom @ pt_mstr.pt_phantom
        ps_ps_code ptmstr.pt_iss_pol @ pt_mstr.pt_iss_pol ps_start ps_end
        ps_scrp_pct ps_lt_off with frame det2.

        if page-size - line-count < 1 then do:
           page.
           down 1 with frame det2.
        end.
        put ptmstr.pt_desc1 at 13 space ptmstr.pt_desc2 skip.

        if page-size - line-count < 1 then do:
           page.
           down 1 with frame det2.
        end.
        if length(ps_rmks) <> 0 then put ps_rmks at 12 skip.

        if level < maxlevel or maxlevel = 0 then do:
           comp = ps_par.
           level = level + 1.
           find first ps_mstr use-index ps_comp where ps_comp = comp
           no-lock no-error.
        end.
        else do:
           find next ps_mstr use-index ps_comp where ps_comp = comp
           no-lock no-error.
        end.
     end.
     else do:
        find next ps_mstr use-index ps_comp where ps_comp = comp
        no-lock no-error.
     end.
      end.

      {mfrpexit.i}
      if skpge then page.
      else down 1 with frame det2.
   end.

   /* REPORT TRAILER */
   {mfrtrail.i}
end.

**G265***********************************************************************
**G265***********************************************************************
**G265***********************************************************************
**G265**********************************************************************/

/*K106*/ {wbrp04.i}
